import { __awaiter, __decorate, __extends, __generator, __metadata } from "tslib";
import { MdcComponent } from '@aurelia-mdc-web/base';
import { MDCLinearProgressFoundation } from '@material/linear-progress';
import { bindable } from 'aurelia-typed-observable-plugin';
import { useView, inject, PLATFORM, customElement } from 'aurelia-framework';
/**
 * @selector mdc-linear-progress
 */
var MdcLinearProgress = /** @class */ (function (_super) {
    __extends(MdcLinearProgress, _super);
    function MdcLinearProgress() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MdcLinearProgress.prototype.progressChanged = function () {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            var determinate;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, this.initialised];
                    case 1:
                        _c.sent();
                        determinate = this.progress !== undefined && !isNaN(this.progress);
                        (_a = this.foundation) === null || _a === void 0 ? void 0 : _a.setDeterminate(determinate);
                        if (determinate) {
                            (_b = this.foundation) === null || _b === void 0 ? void 0 : _b.setProgress(this.progress);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    MdcLinearProgress.prototype.reverseChanged = function () {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.initialised];
                    case 1:
                        _b.sent();
                        (_a = this.foundation) === null || _a === void 0 ? void 0 : _a.setReverse(this.reverse);
                        return [2 /*return*/];
                }
            });
        });
    };
    MdcLinearProgress.prototype.bufferChanged = function () {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.initialised];
                    case 1:
                        _b.sent();
                        if (this.buffer !== undefined && !isNaN(this.buffer)) {
                            (_a = this.foundation) === null || _a === void 0 ? void 0 : _a.setBuffer(this.buffer);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    MdcLinearProgress.prototype.openChanged = function () {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, this.initialised];
                    case 1:
                        _c.sent();
                        if (this.open) {
                            (_a = this.foundation) === null || _a === void 0 ? void 0 : _a.open();
                        }
                        else {
                            (_b = this.foundation) === null || _b === void 0 ? void 0 : _b.close();
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    // eslint-disable-next-line @typescript-eslint/require-await
    MdcLinearProgress.prototype.initialise = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.progressChanged();
                return [2 /*return*/];
            });
        });
    };
    MdcLinearProgress.prototype.getDefaultFoundation = function () {
        var _this = this;
        // DO NOT INLINE this variable. For backward compatibility, foundations take a Partial<MDCFooAdapter>.
        // To ensure we don't accidentally omit any methods, we need a separate, strongly typed adapter variable.
        var adapter = {
            addClass: function (className) {
                _this.root.classList.add(className);
            },
            forceLayout: function () {
                _this.root.getBoundingClientRect();
            },
            setBufferBarStyle: function (styleProperty, value) {
                var bufferBar = _this.root.querySelector(MDCLinearProgressFoundation.strings.BUFFER_BAR_SELECTOR);
                if (bufferBar) {
                    bufferBar.style.setProperty(styleProperty, value);
                }
            },
            setPrimaryBarStyle: function (styleProperty, value) {
                var primaryBar = _this.root.querySelector(MDCLinearProgressFoundation.strings.PRIMARY_BAR_SELECTOR);
                if (primaryBar) {
                    primaryBar.style.setProperty(styleProperty, value);
                }
            },
            hasClass: function (className) { return _this.root.classList.contains(className); },
            removeAttribute: function (attributeName) {
                _this.root.removeAttribute(attributeName);
            },
            removeClass: function (className) {
                _this.root.classList.remove(className);
            },
            setAttribute: function (attributeName, value) {
                _this.root.setAttribute(attributeName, value);
            },
        };
        return new MDCLinearProgressFoundation(adapter);
    };
    __decorate([
        bindable.number,
        __metadata("design:type", Number)
    ], MdcLinearProgress.prototype, "progress", void 0);
    __decorate([
        bindable.booleanAttr,
        __metadata("design:type", Boolean)
    ], MdcLinearProgress.prototype, "reverse", void 0);
    __decorate([
        bindable.number,
        __metadata("design:type", Number)
    ], MdcLinearProgress.prototype, "buffer", void 0);
    __decorate([
        bindable.booleanAttr,
        __metadata("design:type", Boolean)
    ], MdcLinearProgress.prototype, "open", void 0);
    MdcLinearProgress = __decorate([
        inject(Element),
        useView(PLATFORM.moduleName('./mdc-linear-progress.html')),
        customElement('mdc-linear-progress')
    ], MdcLinearProgress);
    return MdcLinearProgress;
}(MdcComponent));
export { MdcLinearProgress };
//# sourceMappingURL=mdc-linear-progress.js.map